//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 PaleVioletRed
#property indicator_color2 DeepSkyBlue
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame        = PERIOD_CURRENT;
extern int                EmaPeriod        = 13;
extern int                MacdFastPeriod   = 12;
extern int                MacdSlowPeriod   = 26;
extern int                MacdSignalPeriod =  9;
extern ENUM_APPLIED_PRICE Price            = PRICE_CLOSE;
extern bool               alertsOn         = false;
extern bool               alertsOnCurrent  = true;
extern bool               alertsMessage    = true;
extern bool               alertsSound      = false;
extern bool               alertsNotify     = false;
extern bool               alertsEmail      = false;
extern string             soundFile        = "alert2.wav";

//
//
//
//
//

double impulseDn[];
double impulseUp[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,impulseDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,impulseUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   
      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(TimeFrame)+" Elder impulse");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][4];
#define _ema   0
#define _macdv 1
#define _macds 2
#define _macdo 3

//
//
//
//
//

int start()
{
   double alpha = 2.0 / (1.0+MacdSignalPeriod);
   int i,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { impulseDn[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         work[r][_ema]   = iMA(NULL,0,EmaPeriod,0,MODE_EMA,Price,i); 
         work[r][_macdv] = iMA(NULL,0,MacdFastPeriod,0,MODE_EMA,Price,i)-iMA(NULL,0,MacdSlowPeriod,0,MODE_EMA,Price,i);
         work[r][_macds] = work[r-1][_macds]+alpha*(work[r][_macdv]-work[r-1][_macds]);
         work[r][_macdo] = work[r][_macdv]-work[r][_macds];
       
         //
         //
         //
         //
         //
         
         impulseDn[i]=EMPTY_VALUE;
         impulseUp[i]=EMPTY_VALUE;
         trend[i]    =EMPTY_VALUE;
            double cOpen  = Open[i];
            double cClose = Close[i];
         if (work[r][_ema]<work[r-1][_ema] && work[r][_macdo]<work[r-1][_macdo]) trend[i] = -1;
         if (work[r][_ema]>work[r-1][_ema] && work[r][_macdo]>work[r-1][_macdo]) trend[i] =  1;
         if (trend[i] == -1) { impulseDn[i]=MathMax(cClose,cOpen); impulseUp[i]=MathMin(cClose,cOpen); }        
         if (trend[i] ==  1) { impulseDn[i]=MathMin(cClose,cOpen); impulseUp[i]=MathMax(cClose,cOpen); }
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; 
      
        //
        //
        //
        //
        //
        if (trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar+1] != 1  && trend[whichBar] == 1) doAlert(whichBar,"up");
           if (trend[whichBar+1] !=-1  && trend[whichBar] ==-1) doAlert(whichBar,"down");
        }
        
      }         
      return(0);
   }     

   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         trend[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,EmaPeriod,MacdFastPeriod,MacdSlowPeriod,MacdSignalPeriod,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
         impulseDn[i] = EMPTY_VALUE;
         impulseUp[i] = EMPTY_VALUE;

            cOpen  = Open[i];
            cClose = Close[i];

      if (trend[i] == -1) { impulseDn[i]=MathMax(cClose,cOpen); impulseUp[i]=MathMin(cClose,cOpen); }       
      if (trend[i] ==  1) { impulseDn[i]=MathMin(cClose,cOpen); impulseUp[i]=MathMax(cClose,cOpen); }
   }
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Elder Impulse ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Elder Impulse "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

